<?php

class ProAddon {

	private $_tpls = array();

	function _init()
	{
		add_action('pt_display_attributes', array($this, 'a__pt_display_attributes'));
		add_filter('pt_template_path', array($this, 'f__pt_template_path'), 10, 2);
		add_filter('pt_template_description', array($this, 'f__pt_template_description'), 10, 2);
	}


	function a__pt_display_attributes($post)
	{
		$table = get_post_meta($post->ID, '_tableinfo', true);
		if (empty($this->_tpls)) {
			$this->_tpls = $tpls = $this->_get_templates("$this->path/themes");
		} else {
			$tpls = $this->_tpls;
		}

		?><p>
			<label for="pt[template]"><strong>Choose Template: </strong> 
				<select name="pt[template]">
					<option value="default">Default</option>
					<?php foreach ($tpls as $t) { ?>
					<option value="<?php echo $t['handle']; ?>" <?php if (isset($table['template']) && $t['handle'] == $table['template']) echo 'selected="selected"'; ?>><?php echo $t['name']; ?></option>
					<?php } ?>
				</select>
			</label>
		</p><?php
	}


	function f__pt_template_path($info, $template)
	{
		extract($info);

		if ($template == 'default' || !file_exists("$this->path/themes/$template/template.php")) {
			return $info;
		}

		$path = "$this->path/themes/$template";
		$url = "$this->url/themes/$template";
		$template_path = "$this->path/themes/$template/template.php";

		return compact('path', 'url', 'template_path');
	}


	function f__pt_template_description($desc, $post)
	{
		$table = get_post_meta($post->ID, '_tableinfo', true);

		if (!isset($table['template']) || $table['template'] == 'default' || !file_exists("$this->path/themes/{$table['template']}/template.php")) {
			return $desc;
		}

		if (!isset($this->_tpls[$table['template']])) {
			return $desc;
		}

		return $this->_tpls[$table['template']]['description'];
	}


	private function _get_templates($path)
	{
		$tpls = array();
		$files = scandir($path);

		foreach ($files as $file) :
			if (in_array($file, array('.', '..'))) {
				continue;
			}

			if (is_dir("$path/$file") && file_exists("$path/$file/template.php")) {
				if (preg_match('|\/\*\s*Template Name:\s*([^\n\*]+)(?:\n\s*Description:\s*([^\n\*]+))?|i', file_get_contents("$path/$file/template.php"), $matches)) {
					$tpls[$file] = array(
						'handle' => $file,
						'name' => trim($matches[1]),
						'description' => trim($matches[2])
					);
				}
			}
		endforeach;

		return $tpls;
	}


}